﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr255_1
{
    // Класс с главным методом:
    class Program
    {
        // Обобщенный метод с аргументом - массивом из 
        // элементов обобщенного типа: 
        static void show<T>(T[] array) {
            // Отображение значений элементов массива: 
            for(int k = 0; k < array.Length; k++) {
                Console.Write("|" + array[k]);
            }
            Console.WriteLine("|");
        }
        // Обобщенный метод возвращает результатом массив из 
        // элементов обобщенного типа: 
        static T[] create<T>(int n) {
            // Создание массива из элементов обобщенного типа: 
            T[] array = new T[n];
            // Результат метода - ссылка на массив: 
            return array;
        }
        // Обобщенный метод для заполнения массива значениями: 
        static void fill<T>(T[] a, T b) {
            // Перебираются элементы массива: 
            for(int k = 0; k < a.Length; k++) {
                // Элементу массива присваивается значение: 
                a[k] = b;
            }
        }
        // Обобщенный метод результатом возвращает значение 
        // случайного элемента из массива: 
        static T getRand<T>(T[] a, Random rnd){
            // Результат метода: 
            return a[rnd.Next(a.Length)];
        }

        // Главный метод: 
        static void Main()
        {
            // Создание объекта для генерирования чисел:
            Random rnd = new Random();
            // Создание массивов:
            string[] A = { "one", "two", "three" };
            int[] B = { 2, 3, 5, 8, 13, 21 };
            char[] C = { 'c', 'h', 'a', 'r', 'l', 'i' };
            // Вызов обобщенных методов: 
            show(A);
            show(B);
            Console.WriteLine("Случайные числа:"); 
            for (int k = 1; k <= 10; k++)
            {
                Console.Write(getRand(B, rnd) + " ");
            }
            Console.WriteLine();
            show(C);
            Console.WriteLine("Случайные символы:"); 
            for (int k = 1; k <= 10; k++)
            {
                Console.Write(getRand(C, rnd) + " ");
            }
            Console.WriteLine();
            // Создание символьного массива вызовом метода: 
            char[] symbs = create<char>(6);
            // Заполнение массива символами: 
            fill(symbs, 'W');
            // Отображение содержимого массива: 
            show(symbs);
            // Создание целочисленного массива вызовом метода: 
            int[] nums = create<int>(7);
            // Заполнение массива числами: 
            fill(nums, 3);
            // Отображение содержимого массива: 
            show(nums);
            // Задержка:
            Console.ReadLine();
        }
    }
}
